ResourceAdapterFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jca.support

## Class ResourceAdapterFactoryBean

- java.lang.Object
- - org.springframework.jca.support.ResourceAdapterFactoryBean

- All Implemented Interfaces:
    DisposableBean, FactoryBean<ResourceAdapter>, InitializingBean

      public class ResourceAdapterFactoryBean
      extends Object
      implements FactoryBean<ResourceAdapter>, InitializingBean, DisposableBean

  `FactoryBean` that bootstraps the specified JCA 1.5 `ResourceAdapter`, starting it with a local `BootstrapContext` and exposing it for bean references. It will also stop the ResourceAdapter on context shutdown. This corresponds to 'non-managed' bootstrap in a local environment, according to the JCA 1.5 specification.

  This is essentially an adapter for bean-style bootstrapping of a JCA ResourceAdapter, allowing the BootstrapContext or its elements (such as the JCA WorkManager) to be specified through bean properties.

  Since:
    2.0.3
  Author:
    Juergen Hoeller
  See Also:
    `setResourceAdapter(javax.resource.spi.ResourceAdapter)`, `setBootstrapContext(javax.resource.spi.BootstrapContext)`, `setWorkManager(javax.resource.spi.work.WorkManager)`, `ResourceAdapter.start(javax.resource.spi.BootstrapContext)`, `ResourceAdapter.stop()`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResourceAdapterFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Builds the BootstrapContext and starts the ResourceAdapter with it.
    `void` | `destroy()` Stops the ResourceAdapter.
    `ResourceAdapter` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends ResourceAdapter>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setBootstrapContext(BootstrapContext bootstrapContext)` Specify the JCA BootstrapContext to use for starting the ResourceAdapter.
    `void` | `setResourceAdapter(ResourceAdapter resourceAdapter)` Specify the target JCA ResourceAdapter, passed in as configured instance which hasn't been started yet.
    `void` | `setResourceAdapterClass(Class resourceAdapterClass)` Specify the target JCA ResourceAdapter as class, to be instantiated with its default configuration.
    `void` | `setWorkManager(WorkManager workManager)` Specify the JCA WorkManager to use for bootstrapping the ResourceAdapter.
    `void` | `setXaTerminator(XATerminator xaTerminator)` Specify the JCA XATerminator to use for bootstrapping the ResourceAdapter.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ResourceAdapterFactoryBean

          public ResourceAdapterFactoryBean()

  - ### Method Detail

    - #### setResourceAdapterClass

          public void setResourceAdapterClass(Class resourceAdapterClass)

      Specify the target JCA ResourceAdapter as class, to be instantiated with its default configuration.

      Alternatively, specify a pre-configured ResourceAdapter instance through the "resourceAdapter" property.

      See Also:
        `setResourceAdapter(javax.resource.spi.ResourceAdapter)`

    - #### setResourceAdapter

          public void setResourceAdapter(ResourceAdapter resourceAdapter)

      Specify the target JCA ResourceAdapter, passed in as configured instance which hasn't been started yet. This will typically happen as an inner bean definition, configuring the ResourceAdapter instance through its vendor-specific bean properties.

    - #### setBootstrapContext

          public void setBootstrapContext(BootstrapContext bootstrapContext)

      Specify the JCA BootstrapContext to use for starting the ResourceAdapter.

      Alternatively, you can specify the individual parts (such as the JCA WorkManager) as individual references.

      See Also:
        `setWorkManager(javax.resource.spi.work.WorkManager)`, `setXaTerminator(javax.resource.spi.XATerminator)`

    - #### setWorkManager

          public void setWorkManager(WorkManager workManager)

      Specify the JCA WorkManager to use for bootstrapping the ResourceAdapter.
      See Also:
        `setBootstrapContext(javax.resource.spi.BootstrapContext)`

    - #### setXaTerminator

          public void setXaTerminator(XATerminator xaTerminator)

      Specify the JCA XATerminator to use for bootstrapping the ResourceAdapter.
      See Also:
        `setBootstrapContext(javax.resource.spi.BootstrapContext)`

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws ResourceException

      Builds the BootstrapContext and starts the ResourceAdapter with it.
      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Throws:
        `ResourceException`
      See Also:
        `ResourceAdapter.start(javax.resource.spi.BootstrapContext)`

    - #### getObject

          public ResourceAdapter getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<ResourceAdapter>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends ResourceAdapter> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<ResourceAdapter>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<ResourceAdapter>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

    - #### destroy

          public void destroy()

      Stops the ResourceAdapter.
      Specified by:
        `destroy` in interface `DisposableBean`
      See Also:
        `ResourceAdapter.stop()`